/*
    iprig - ham radio via internet
    Copyright (C) 2007 Ladislav Vaiz <ok1zia@nagano.cz>
    and authors of web browser Links 0.96

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#include "header.h"


void do_not_optimize_here(void *p)
{
    /* stop GCC optimization - avoid bugs in it */
}


static inline void force_dump(void)
{
    fprintf(stderr, "Forcing core dump");
    fflush(stderr);
    raise(SIGSEGV);
    exit(1);
}

void debug_internal(char *file, int line, char *m, ...)
{
    va_list l;
    
    va_start(l, m);
    fprintf(stderr, "INTERNAL ERROR at %s:%d ", file, line);
    vfprintf(stderr, m, l);
    fprintf(stderr, "\n");
    force_dump();
}

void dbg(char *m, ...)
{
    va_list l;

    if (!opt_d) return;
    va_start(l, m);
    vfprintf(stderr, m, l);
    va_end(l);
    fflush(stderr);
} 
