#!/usr/bin/perl -w
#
use Data::Dumper;

opendir(DH, ".") or die;
#foreach $file ("alsa.c", "oss.c"){
foreach $file (readdir(DH)){
    next if ($file eq '.' or $file eq '..');
    next if (! -f $file);
    next if ($file!~/.+\.c$/);
#    print $file."\n";

    open(FD, $file) or die;
    while ($s=<FD>){
        next if ($s!~/rc_getopt\s*\(\"(.*?)\"\)/); #"
        $opt=$1;
#        print "opt='$opt'\n";

        if ($s=~/\/\*\s*(.+?)\s*\*\//) {
            $comment=$1;
        }else{
#            print Dumper($opt, $opts{$opt});
            next if (defined($opts{$opt}) && length($opts{$opt})>0);
            $comment="";
        }
#        print $s."\n";
#        print "$opt - $comment\n";        
        $opts{$opt}=$comment;
        
    }
    close(FD);
    
}
closedir(DH);



$len = 0;
foreach $key (keys(%opts)) {
    $len = length($key) if (length($key) > $len); 
}

open(FD, ">help.c") or die;
print FD "char *help=\n";
foreach $key (sort(keys(%opts))){
    printf FD "\"%-$len"."s - %s\\n\"\n", $key, $opts{$key};
}
print FD ";\n";
close(FD);

